#!/bin/bash
#
# function
#
create_file()
{
for i in /home/*;
do
      for j in .mozilla .cache .config .local .pki .dbus;
      do
         echo "$i/$j" >> $CLAMONACC_LIST
      done
done
}

#
# main
#
while [ ! -S /run/clamav/clamd.ctl ];
do
sleep 1;
done
LOG_FILE=/var/log/clamav/clamonacc.log
DATE=$(date +%F)
CLAMONACC_BIN="$(which clamonacc)"
NICE_BIN=$(which nice)
IONICE_BIN=$(which ionice)
if [ -e $LOG_FILE ]; then
	FILE_SIZE=$(du -m $LOG_FILE | cut -f1)
	if [ "$FILE_SIZE" -ge 100 ]; then
		echo "=========" >> $LOG_FILE
		echo "Clamonacc end log: $DATE" >> $LOG_FILE
		echo "=========" >> $LOG_FILE
		gzip -c $LOG_FILE > $LOG_FILE."$DATE".gz
		rm $LOG_FILE
		echo "=========" > $LOG_FILE
		echo "Clamonacc begin log: $DATE" >> $LOG_FILE
		echo "=========" >> $LOG_FILE
		LIMIT_LOG=5
		LIMIT_COUNT="$(find /var/log/clamav/clamonacc.log.*.gz  2>/dev/null |sort|uniq|wc -l)"
		if [ "$LIMIT_COUNT" -gt $LIMIT_LOG ]; then
			let 'DELTA_LIMIT = LIMIT_COUNT-LIMIT_LOG'
			for i in $(find /var/log/clamav/clamonacc.log.*.gz |sort|uniq|head -n $DELTA_LIMIT); do
			   rm "$i"
			done
		fi
	fi
	else
		echo "=========" > $LOG_FILE
		echo "Clamonacc begin log: $DATE" >> $LOG_FILE
		echo "=========" >> $LOG_FILE
fi
CLAMONACC_LIST=/etc/linkat-clamonacc-list
if [ -e "$CLAMONACC_LIST" ]; then
	FLAG=0
	for i in /home/*;
	do
		if [ -z "$(grep -i $i $CLAMONACC_LIST)" ]; then
			FLAG=1
		fi
	done
	if [ $FLAG -eq 1 ]; then
		rm $CLAMONACC_LIST
		create_file
	fi
else
	create_file
fi
"$NICE_BIN" -n 19 "$IONICE_BIN" -c2 -n7 "$CLAMONACC_BIN" -F --config-file=/etc/clamav/clamd.conf --exclude-list="$CLAMONACC_LIST" --log=/var/log/clamav/clamonacc.log --move=/tmp > /dev/null 2>&1
